unit MMTimer;

interface

Uses  Windows, MMSystem;

type
  //http://blog.sina.com.cn/s/blog_5e15da1a0100nb98.html
  //ǻýĸ߾ȻصʵֵĶʱ
  TMMTimeProc = procedure () of object;
  TMMTimer = class
  private
    FInternal : Cardinal; //ʱļʱ䣬λΪ룬ĬΪ1000
    FEnable : Boolean;  //ʱǷУĬΪFALSE
    FProcTimeCallback : TFnTimeCallback;//صָ
    FOnTimeProc : TMMTimeProc;//ڻصʱĶʱ¼
    FHTimerID : Integer;//ʱIDֹͣʱʹ

    procedure SetInternal(const Value: Cardinal);
    procedure SetEnable(const Value: Boolean);
  public
    property Internal : Cardinal read FInternal write SetInternal default 1000;
    property Enable : Boolean read FEnable write SetEnable default FALSE;
    property OnTimeProc : TMMTimeProc read FOnTimeProc write FOnTimeProc;
    constructor Create;
    destructor Destroy;override;
  end;

implementation

procedure DoTimer(uTimerID, uMessage: UINT; dwUser, dw1, dw2: DWORD) stdcall;
var
  obj : TMMTimer;
begin
  obj := TMMTimer(dwUser);  //dwUserʵǶʱĵַ
  if Assigned(obj.OnTimeProc)then
  begin
    obj.OnTimeProc;
  end;
end;

{ TMMTimer }
constructor TMMTimer.Create;
begin
  inherited;
  FInternal := 1000;  //ĬΪ1
  FEnable := FALSE; //ʱ
  FOnTimeProc := NIL;
  //еĺָֻһҪdwUserֲͬĶص
  FProcTimeCallback := DoTimer;
end;


destructor TMMTimer.Destroy;
begin
  Enable := FALSE;
  inherited;
end;

procedure TMMTimer.SetEnable(const Value: Boolean);
begin
  if Value = FEnable then
    exit;

  FEnable := Value;
  if FEnable then
  begin
  //Ѷַ룬صʱأһʾڻصڶ0Ϊ߾
    FHTimerID := TimeSetEvent( FInternal, 0, FProcTimeCallback, Integer(Self), 1 );
  end
  else
  begin
    TimeKillEvent( FHTimerID );
  end;
end;

procedure TMMTimer.SetInternal(const Value: Cardinal);
begin
  if FInternal <> Value then
  begin
    FInternal := Value;
    if FEnable then
    begin
      //ʱѾʱҪֹͣʱ
      Enable := FALSE;
      Enable := TRUE;
    end;
  end;
end;

end.
